find_program(LSB_RELEASE_EXEC lsb_release)
find_program(DPKG_BUILDPACKAGE dpkg-buildpackage)

if (LSB_RELEASE_EXEC AND DPKG_BUILDPACKAGE)
  execute_process(COMMAND env LC_ALL=C date "+%a, %-d %b %Y %H:%M:%S %z"
    OUTPUT_VARIABLE DEBIAN_DATE OUTPUT_STRIP_TRAILING_WHITESPACE)
  execute_process(COMMAND /bin/sh "-c" "${LSB_RELEASE_EXEC} -cs"
    OUTPUT_VARIABLE DEBIAN_CODENAME OUTPUT_STRIP_TRAILING_WHITESPACE)
  set(DEBIAN_RUNTIME_DEPENDS_PLACEHOLDER
    "\${shlibs:Depends},\${misc:Depends},\${misc:Pre-Depends}")

  if(NOT CMAKE_INSTALL_PREFIX)
    set(CMAKE_INSTALL_PREFIX "/usr")
  endif()
  if(NOT ENABLE_MODEL)
    set(ENABLE_MODEL ON)
  endif()

  configure_file(${CMAKE_SOURCE_DIR}/debian/control.in
                 ${CMAKE_SOURCE_DIR}/debian/control)
  configure_file(${CMAKE_SOURCE_DIR}/debian/changelog.in
                 ${CMAKE_SOURCE_DIR}/debian/changelog)
  configure_file(${CMAKE_SOURCE_DIR}/debian/rules.in
                 ${CMAKE_SOURCE_DIR}/debian/rules @ONLY)
  file(WRITE ${CMAKE_SOURCE_DIR}/debian/compat "10")

  if(NOT TARGET deb)
    add_custom_target(deb
      COMMENT "Build deb package"
      WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
      COMMAND ${DPKG_BUILDPACKAGE} -F -uc -us -ui)
  endif()
  if(NOT TARGET deb-bin)
    add_custom_target(deb-bin
      COMMENT "Build deb package (only binary)"
      WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
      COMMAND ${DPKG_BUILDPACKAGE} -b -uc -us -ui)
  endif()
  if(NOT TARGET deb-src)
    add_custom_target(deb-src
      COMMENT "Build deb package (only source)"
      WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
      COMMAND ${DPKG_BUILDPACKAGE} -S -uc -us -ui)
  endif()
endif()
